#ifndef _IGES_PARSER_MAIN_H_
#define _IGES_PARSER_MAIN_H_

#include "BODY.h"

#define SECTION_NUM		 5			// ZNV̐(S,G,D,P,T)
#define COLUMN_MAX_	     82			// 1s̃J('\n''\0'܂)
#define COLUMN_MAX       80			// 1s̃J('\n''\0'͊܂܂Ȃ)
#define COL_CHAR		 73			// ZNVʕ̃J
#define COL_P_DIRECTORY  65			// p[^ł̃fBNgւ̋t|C^J
#define GLOBALPARAMNUM	 25			// O[õp[^
#define FIELD_NUM		 8			// fBNg1tB[h̕
#define DIRECTORYPARANUM 20			// fBNg̃p[^
#define SECTION_START		0		// X^[gZNVʗpV{
#define SECTION_GLOBAL		1		// O[oZNVʗpV{
#define SECTION_DIRECTORY	2		// fBNgZNVʗpV{
#define SECTION_PARAMETER	3		// p[^ZNVʗpV{
#define SECTION_TERMINATE	4		// ^[~l[gZNVʗpV{
#define MAIN_ENTITY_TYPE_NUM 9		// ǂݍݑΏۂƂȂGeBeB^Cv̐
#define NRBS_PARAM_MAX  200		// NRBSȖʁEȐŒ`p[^̍ől


// O[op[^̃V{`
enum GlobalParamType{
	PARAM_DELIMITER=1,			// p[^f~^
	RECORD_DELIMITER,			// R[hf~^
	SEND_PRODUCT_ID,			// 葤ihc
	FILE_NAME,					// t@C
	SEND_SYSTEM_ID,				// 葤VXehc
	PRIRPO_VERSION,				// vvZbTo[W
	INT_LENGTH,					// l̒
	FLOAT_PNT_LENGTH,			// Px_w̍ől
	FLOAT_PNT_FIGURE,			// Px_L
	DOUBLE_PNT_LENGTH,			// {x_w̍ől
	DOUBLE_PNT_FIGURE,			// {x_L
	RECIVE_PRODUCT_ID,			// 󂯎葤ihc
	MODEL_SCALE,				// fXP[
	UNIT_FLAG,					// PʃtO
	UNIT,						// P
	LINE_THICKNESS_NUMBER,		// ̍őޕʐ
	LINE_THICKNESS,				// ̍ől
	DATE_MAKE_FILE,				// t@C쐬
	MIN_ACCRACY,				// ŏx
	MODEL_SPACE_SIZE,			// fԂ̑傫
	FILE_MAKER_NAME,			// t@C쐬
	BELONG,						// 
	IGES_VERSION,				// o[W
	DRAFTING_STANDARD,			// }Ki
	DATE_MAKE_MODEL				// f쐬
};

// fBNgp[^̃V{`
enum DirectoryParamType{
	ENTITY_TYPE_NUM,			// vfԍ
	PARAM_DATA,					// p[^ւ̃|C^
	STRUCTURE,					// XgN`
	LINE_FONT_PATTERN,			// 
	LEVEL,						// x
	VIEW_,						// r[
	TRAN_MATRIX,				// }gbNXւ̃|C^
	LABEL_DISP_ASSOC,			// x\
	STATUS_NUM,					// XeC^X
	SEQUENCE_NUM,				// V[PXԍ
	ENTITY_TYPE_NUM_,			// vfԍ
	LINE_WEIGHT_NUM,			// 
	COLOR_NUM,					// F
	PARAM_LINE_COUNT,			// p[^̃C
	FORM_NUM,					// `ԍ
	RESERVED1,					// \
	RESERVED2,					// \
	ENTITY_LABEL,				// vf̃x
	ENTITY_SUBSCRIPT_NUM,		// TuXNvg
	SEQUENCE_NUM_				// V[PXԍ
};

// O[o̕Kvp[^\
typedef struct{
	double scale;			// f̃XP[
	int    unit_flag;		// PʃtO
	double space_size;		// fԂ̑傫
}GlobalParam;

// fBNg̕Kvp[^\
typedef struct{
	int entity_type;		// vfԍ
	int entity_count;		// Ԗڂentity_type\
	int p_param;			// p[^ւ̃|C^
	int p_tm;				// }gbNXւ̃|C^
	int blank_stat;			// \
	int subordinate_stat;	// ]
	int useflag_stat;		// entitygpӐ}
	int seq_num;			// V[PXԍ
	int param_line_count;	// p[^̃C
}DirectoryParam;


// IGESp[T[pNX`
class IGES_PARSER
{
public:
	int IGES_Parser_Main(BODY *);	// IGESt@C̃p[Tmain
	IGES_PARSER();					// RXgN^

private:
	void GetSectionLine(FILE *,int []);								// eZNṼC𒲂ׂ
	int GetStartSection(FILE *,int);								// X^[g̓ǂݍ
	int GetGlobalSection(FILE *,GlobalParam *,int);					// O[o̓ǂݍ
	int GetDirectorySection(FILE *,DirectoryParam *,int [],int);	// fBNg̓ǂݍ
	void GetStatusNumber(char [],DirectoryParam *);					// fBNg̏#9擾
	int GetParameterSection(FILE *,DirectoryParam *,BODY,int);		// p[^̓ǂݍ
	int GetTerminateSection(FILE *);								// ^[~l[g̓ǂݍ݁iXPgj
	void GetType(int,int []);										// eGeBeB^Cv̐L
	int GetCirAPara(char [],int,DirectoryParam *,BODY);				// Type100 ~E~ʂ̓ǂݍ
	int GetCompCPara(char [],int,DirectoryParam *,int,BODY);		// Type102 Ȑ̓ǂݍ
	int GetConAPara(char [],int,DirectoryParam *,BODY);				// Type104 ~Ȑ̓ǂݍ
	int GetLinePara(char [],int,DirectoryParam *,BODY);				// Type110 ̓ǂݍ
	int GetTMatPara(char [],int,DirectoryParam *,BODY);				// Type124 ϊs̓ǂݍ
	int GetNurbsCPara(char [],int,DirectoryParam *,BODY);			// Type126 NRBSȐ̓ǂݍ
	int GetNurbsSPara(char [],int,DirectoryParam *,BODY);			// Type128 NRBSȖʂ̓ǂݍ
	int GeConpSPara(char [],int,DirectoryParam *,int,BODY);			// Type142 ʏ̓ǂݍ
	int GetTrmSPara(char [],int,DirectoryParam *,BODY);				// Type144 gʂ̓ǂݍ
	int CatchStringI(char **);										// J}܂ł̐lǂݍŕԂ(int)
	double CatchStringD(char **);									// J}܂ł̐lǂݍŕԂ(double)
	int ChangeEntityforNurbs(DirectoryParam *,BODY,int);			// GeBeBSNURBS֕ύX
	int SearchMaxCoord(BODY *,int []);								// SẴGeBeBɂWl̍ől𒲂ׂ
	void *GetDEPointer(int ,BODY);									// DEւ̃|C^ۂ̍\̂ւ̃|C^Ԃ
	int SearchEntType(DirectoryParam *,int,int);					// DEւ̃|C^̒lGeBeB̃^Cv𒲂ׂĕԂ
	void InitDisplayStat(DispStat *);								// eGeBeB̕\ݒ
	int GetNurbsCFromLine(int,int,BODY);							// Type110Type126̃p[^f[^𓾂
	int GetNurbsCFromCirA(int,int,BODY);					// Type100Type126̃p[^f[^𓾂
	int CirAToNurbsC_seg1(int,int,BODY,Coord [],double);	// Type1001ZOg̏ꍇ
	int CirAToNurbsC_seg2(int,int,BODY,Coord [],double);	// Type1002ZOg̏ꍇ
	int CirAToNurbsC_seg3(int,int,BODY,Coord [],double);	// Type1003ZOg̏ꍇ
	int CirAToNurbsC_seg4(int,int,BODY,Coord [],double);	// Type1004ZOg̏ꍇ
	int TransformNurbsC(int,int,BODY);						// NURBSȐWϊ

private:
	BODY *body;
	int *TypeNum;
	char buf[COLUMN_MAX_];				 // ėpobt@
	int  entity[ALL_ENTITY_TYPE_NUM];	 // GeBeB̔ԍi[z
	int  TypeCount[ALL_ENTITY_TYPE_NUM]; // eGeBeB^Cv̐탁[mېi[
};

#endif
